#MessRC1.py  1k-20M, 1R-10k, 1nF-10µF, 1µF-1000µF, Dioden, NPN
from machine import Pin
import time

ad0 = machine.ADC(0)
a0 = Pin(26, Pin.IN)
ad1 = machine.ADC(1)
a1 = Pin(27, Pin.IN)
    
while True:
    u0=ad0.read_u16()-300   #Nullabgleich
    u1=ad1.read_u16()-300   
    if u1<0:
        u1=0
    v1=int(u1/65235*3300)   #in mV
    if u0<0:
        u0=0
    v0=int(u0/65235*3300)
    print (v1,"mV",v0,"mV  ", end='') #Spannungen
    ib=(v0-v1)/100          #NPN-Transistor
    ic=(3300-v0)/1-ib
    if ib>0 & v1<1000:
        v=0
        if ib>0:
            v=int(ic/ib)    #Stromverstärkung
        if (v1<1000) & (v>1):
            print ("NPN V=",int(v))
    r1 =int(u1/(64860-u1)*101 +0.5) #R1 in k
    if r1<0:
        r1=60000
    u0=ad0.read_u16()-200
    if u0<0:
        u0=0
    r0 =int(u0/(65200-u0) *1000)   #R0 in Ohm
    if r0>50000:
        r0=50000
    if r0<0:
        r0=100000
    if (r1<60000)&(r0>49000):
        print(r1, "k")
    if (v0<3000)&(v1>(v0-100)):
        print(r0, "R")

    if (v0>3000)&(v1>3000):    #Kapazitätsmessung
        a0 = Pin(26, Pin.OUT)
        a0.value(0)            #Entladen
        time.sleep(0.1)
        n=0
        a0 = Pin(26, Pin.IN)
        while a0.value() == 0: #Ladezeit
            n=n+1
        if n<0:
            n=0
        c1=int (n*18/1000 + 0.5) #c1 in µF
        if c1>0:
            print (c1,"µF")
        a0 = Pin(26, Pin.OUT)  #Elko laden
        a0.value(1)
        time.sleep(0.1)
        a0 = Pin(26, Pin.IN)
        a0.value(0)

        a1 = Pin(27, Pin.OUT)
        time.sleep(0.1)        #Entladen
        n=0
        a1 = Pin(27, Pin.IN)
        while a1.value() == 0: #Ladezeit
            n=n+1
        n=n-20
        if n<0:
            n=0
        c2=int(n*180/1000)     #c2 in nF
        if (c2>0)&(c1==0):
            print (c2,"nF")
    time.sleep(1)
    

    


    