#VFO1.py Kurzwellen VFO, Out P2

from machine import Pin, PWM, Timer
import time
pwm1 = PWM(Pin(2))

f=6335
fout=f
sp=1
df=5


def tune(value):
    global f, df, sp, fout
    clock = 100000
    min2=0
    delta1=500
    for j in range (80,120):
        m=j*0.8
        n = round(1000*m/f)
        f2=1000*m/n
        delta2=abs(f2-f)
        if delta2<delta1:
            delta1=delta2
            min2=f2
            divisor=n
            clock=m
    for j in range (60,120):
        m=j*1
        n = round(1000*m/f)
        f2=1000*m/n
        delta2=abs(f2-f)
        if delta2<delta1:
            delta1=delta2
            min2=f2
            divisor=n
            clock=m
    for j in range (50,100):
        m=j*1.2
        n = round(1000*m/f)
        f2=1000*m/n
        delta2=abs(f2-f)
        if delta2<delta1:
            delta1=delta2
            min2=f2
            divisor=n
            clock=m
    for j in range (40,80):
        m=j*1.5
        n = round(1000*m/f)
        f2=1000*m/n
        delta2=abs(f2-f)
        if delta2<delta1:
            delta1=delta2
            min2=f2
            divisor=n
            clock=m
    fout=min2
    clk = 100*int(clock*10)
    #print (f,clk, fout)
    machine.freq(clk*1000)
    pwm1.freq(int(fout)*1000)
    pwm1.duty_u16(32767)
    if sp==1:
        f=f+df

timer = Timer(period=1000, mode=Timer.PERIODIC, callback=tune)

while 1:    
    fnew=input("f=")    
    fin=int(fnew)
    if df>100:
        f=fin
        df=0
    else:
        if fin==0:
            sp=0
        if fin==1:
            df=fin
            sp=1
        if fin==2:
            f=f-df
            sp=0
        if fin==3:
            f=f+df
            sp=0
        if fin>3:
            df=fin
            sp=1
    
    time.sleep (1)
    print (fout,fout-455)
    
    

    